define(['jquery'], function($) {

	var CustomWidget = function() {

		var self = this,
			user, account, settings = {},
			system = Object.assign({}, self.system());

		this.callbacks = {

			render: function() {
				account = AMOCRM.constant('account');
				user = AMOCRM.constant('user');
				system.params = self.params;
				settings = {
					server: self.get_settings().server || 'servicepanel.ru',
					pass: self.get_settings().pass,
					promo: 'comf5' || self.get_settings().promo
				};
				return true;
			},

			init: function() {
				if (typeof WidgetComF5init == 'undefined') {
					localStorage.removeItem('WidgetsComF5' + account.id + account.subdomain);
					$('body').append('<link rel="stylesheet" href="' + self.server() + '/widget/static/loader.css">');
					$.ajax({
						type: 'GET',
						url: self.server() + '/widget/static/loader.js',
						dataType: 'script',
						cache: true
					})
					 .done(function(script, textStatus) {
						WidgetComF5 = new WidgetComF5init(account, system, user, settings);
					})
					 .fail(function(jqxhr, settings, exception) {
						self.error('ServicePanel', 'Ошибка инициализации виджета');
					});
				} else {
					WidgetComF5 = new WidgetComF5init(account, system, user, settings);
				}
				return true;
			},

			onSave: function(fieldlist) {
				let fields = Object.assign({}, fieldlist.fields);
				settings.server = fieldlist.fields.server;
				fields.account_id = account.id;
				fields.domain = account.subdomain;
				fields.timezone = account.timezone;
				fields.language = AMOCRM.lang_id;
				fields.zone = location.host.split('.').pop();
				fields.user_id = user.id;
				fields.user_name = user.name;
				fields.user_login = user.login;
				fields.user_hash = user.api_key || '';
				fields.user_pass = fieldlist.fields.pass || '1234';
				fields.user_phone = fieldlist.fields.phone;
				fields.resp_id = parseInt('4') || 0;
				fields.active = fieldlist.active == 'Y' ? 1 : 0;
				fields.solo = 1;
				fields.client_secret = $($('.view-integration-modal__keys .view-integration-modal__params-block').get(0)).find('.params-block__value').html();
				fields.client_id = $($('.view-integration-modal__keys .view-integration-modal__params-block').get(1)).find('.params-block__value').html();
				fields.temp_code = $($('.view-integration-modal__keys .view-integration-modal__params-block').get(3)).find('.params-block__value').html();
				self.save(fields);
				return true;
			},

			settings: function() {
				let $Wrapp = $('#widget_settings__fields_wrapper');
				if (!(server_isset = $Wrapp.find('input[name=server]').val() || false)) {
					$Wrapp.find('input[name=server]').val(settings.server);
				}
				if (!(phone_isset = $Wrapp.find('input[name=phone]').val() || false)) {
					$Wrapp.find('input[name=phone]').val(user.personal_mobile || '').trigger('change');
				}
				$('input[name=promo]').attr({
					placeholder: 'необязательно'
				});
				if (!(promo_isset = $('input[name=promo]').val() || false)) {
					$('input[name=promo]').val(settings.promo);
				}
				$('#cmdf5mv').html('<iframe width="440" height="250" src="' + $('#cmdf5mv').data('embed') + '" frameborder="0" allowfullscreen></iframe>');
				return true;
			},

			bind_actions: function() {
				return true;
			},
			destroy: function() {},
			contacts: {
				selected: function() {}
			},
			leads: {
				selected: function() {}
			},
			tasks: {
				selected: function() {}
			}
		};

		this.save = function(fields) {
			if (typeof fields == 'undefined' || !fields.server) {
				self.error('Ошибка установки', 'Пересохраните настройки виджета');
				return true;
			}
			$.post(self.server() + '/partners/widget/save', fields)
				.done(function(response) {
					if (response.status == 'ok') {
						$('.modal-overlay').click();
						localStorage.clear();
						setTimeout(function() {
							location.href = '/contacts/list/';
						}, 300);
					} else if (response.errors && Object.keys(response.errors).length > 0) {
						for (var field_key in response.errors) {
							var error = response.errors[field_key];
							self.error('Поле: ' + field_key, error.messages[0]);
						}
					} else {
						self.error('Ошибка установки', 'Некорректный ответ сервера');
					}
				}).fail(function(err) {
					self.error('Ошибка установки', 'Не удалось отправить запрос');
				});
			return true;
		};
		
		this.server = function() {
			return 'https://' + settings.server;
		};
		this.error = function(header, message, wait_time)
		{
			let $Inbox = $('#popups_inbox'),
				zIndex = $Inbox.css('z-index'),
				t = wait_time || 6000;
				
			AMOCRM.notifications.show_message_error({
				text: message || '', header: header || ''
			});
			$Inbox.css('z-index', 9001);
			setTimeout(function() {
				$Inbox.css('z-index', zIndex);
			}, t);
		};
		this.jsonEncode = function(a) {
			return JSON.stringify(a).replace(/&/g, '%26');
		};
		return this;
	};
	return CustomWidget;
});